
package org.eclipse.ajdt.internal.builder;

import javax.swing.*;

import org.eclipse.ui.*;
import org.eclipse.jface.dialogs.*;
import org.eclipse.ajdt.ui.*;
import org.aspectj.asm.*;
import org.aspectj.ajde.*;
import org.aspectj.ajde.internal.*;
import org.aspectj.ajde.ui.swing.DefaultBuildProgressMonitor;


/**
 * @author	Mik Kersten
 */
public class JoinpointProbeBuilder extends AspectJBuildManager {
	
	public static boolean probeIsValid = false;
	
	//private IWorkbench workbench = null;
	
	public JoinpointProbeBuilder() {
		super(MESSAGES, 
			new DefaultBuildProgressMonitor(null),
			Ajde.getDefault().getBuildManager().getBuildOptions());
		this.addListener(new ProbeBuildListener());
	}
	
	private static final TaskListManager MESSAGES = new TaskListManager() {

	    public void addSourcelineTask(String message, SourceLocation sourceLocation, StructureMessage.Kind kind) {
			String msg = message.substring(message.indexOf("\":")+2, message.indexOf(","));
			JOptionPane.showMessageDialog(null, 
				 "Error: " + msg, "Error found in probe", JOptionPane.ERROR_MESSAGE); 
	    }
	    
	    public void addProjectTask(String message, StructureMessage.Kind kind) { }
	    
	    public void clearTasks() { }
	};
	
	private class ProbeBuildListener implements BuildListener {
		
		public void compileStarted(String buildConfig) { }
		
    	public void compileFinished(String buildConfigFile, int buildTime, boolean succeeded, boolean warnings) {
			probeIsValid = succeeded;
		}	
		
		public void compileAborted(String buildConfigFile, String message) { } 
	};
}
