/**********************************************************************
Copyright (c) 2002 IBM Corporation and others.
All rights reserved. This program and the accompanying materials
are made available under the terms of the Common Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/cpl-v10.html
Contributors:
Adrian Colyer - initial version
...
**********************************************************************/
package org.eclipse.ajdt.internal.core;

import java.util.List;

import org.aspectj.ajde.ui.AbstractIcon;
import org.aspectj.ajde.ui.AbstractIconRegistry;
import org.aspectj.ajde.ui.StructureViewNode;
import org.aspectj.ajde.ui.StructureViewNodeFactory;
import org.aspectj.asm.StructureNode;
import org.eclipse.ajdt.internal.core.resources.AJDTIcon;

public class AJDTStructureViewNodeFactory extends StructureViewNodeFactory {

	private AJDTStructureViewNodeFactory( ) { super( null ); }

	/**
	 * Constructor for AJDTStructureViewNodeFatory.
	 * @param arg0
	 */
	public AJDTStructureViewNodeFactory(AbstractIconRegistry iconRegistry) {
		super(iconRegistry);
	}

	/**
	 * This method is called from AJDE to build the nodes of the structure
	 * tre, starting from the leaves up.
	 * @see StructureViewNodeFactory#createConcreteNode(StructureNode, AbstractIcon, List)
	 */
	protected StructureViewNode createConcreteNode(
		StructureNode node,
		AbstractIcon icon,
		List children) {
			// look out for special case "null" icon and replace it with
			// Eclipse's MissingImageDescriptor
			if ( icon == null || icon.getIconResource() == null ) {
				icon = AJDTIcon.MISSING_ICON;	
			}
			//System.out.println( "Creating node:	" + node.getName() );					
			return new AJDTStructureViewNode( node, icon, children );
	}

}
